scala.util

# Try

#### sealed abstract class Try[+T] extends AnyRef

The `Try` type represents a computation that may either result in an exception, or return a successfully computed value. It's similar to, but semantically different from the scala.util.Either type.

Instances of `Try[T]`, are either an instance of scala.util.Success[T] or scala.util.Failure[T].

For example, `Try` can be used to perform division on a user-defined input, without the need to do explicit exception-handling in all of the places that an exception might occur.

Example:

    import scala.util.{Try, Success, Failure}

    def divide: Try[Int] = {
      val dividend = Try(Console.readLine("Enter an Int that you'd like to divide:\n").toInt)
      val divisor = Try(Console.readLine("Enter an Int that you'd like to divide by:\n").toInt)
      val problem = dividend.flatMap(x => divisor.map(y => x/y))
      problem match {
        case Success(v) =>
          println("Result of " + dividend.get + "/"+ divisor.get +" is: " + v)
          Success(v)
        case Failure(e) =>
          println("You must've divided by zero or entered something that's not an Int. Try again!")
          println("Info from the exception: " + e.getMessage)
          divide
      }
    }

An important property of `Try` shown in the above example is its ability to pipeline, or chain, operations, catching exceptions along the way. The `flatMap` and `map` combinators in the above example each essentially pass off either their successfully completed value, wrapped in the `Success` type for it to be further operated upon by the next combinator in the chain, or the exception wrapped in the `Failure` type usually to be simply passed on down the chain. Combinators such as `rescue` and `recover` are designed to provide some type of default behavior in the case of failure.

Note: only non-fatal exceptions are caught by the combinators on `Try` (see scala.util.control.NonFatal). Serious system errors, on the other hand, will be thrown.

Note:: all Try combinators will catch exceptions and return failure unless otherwise specified in the documentation.

`Try` comes to the Scala standard library after years of use as an integral part of Twitter's stack.

Source
  Try.scala
Since

  2.10

Linear Supertypes
AnyRef, Any
Known Subclasses
Failure, Success
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. Try
2. AnyRef
3. Any

Implicitly

1. by any2stringadd
2. by any2stringfmt
3. by any2ArrowAssoc
4. by any2Ensuring

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Instance Constructors

1. #### new Try()

### Abstract Value Members

1. #### abstract def failed: Try[Throwable]

   Completes this `Try` with an exception wrapped in a `Success`.

   Completes this `Try` with an exception wrapped in a `Success`. The exception is either the exception that the `Try` failed with (if a `Failure`) or an `UnsupportedOperationException`.

2. #### abstract def filter(p: (T) ⇒ Boolean): Try[T]

   Converts this to a `Failure` if the predicate is not satisfied.

3. #### abstract def flatMap[U](f: (T) ⇒ Try[U]): Try[U]

   Returns the given function applied to the value from this `Success` or returns this if this is a `Failure`.

4. #### abstract def flatten[U](implicit ev: <:<[T, Try[U]]): Try[U]

   Transforms a nested `Try`, ie, a `Try` of type `Try[Try[T]]`, into an un-nested `Try`, ie, a `Try` of type `Try[T]`.

5. #### abstract def foreach[U](f: (T) ⇒ U): Unit

   Applies the given function `f` if this is a `Success`, otherwise returns `Unit` if this is a `Failure`.

   Applies the given function `f` if this is a `Success`, otherwise returns `Unit` if this is a `Failure`.

   Note: If `f` throws, then this method may throw an exception.

6. #### abstract def get: T

   Returns the value from this `Success` or throws the exception if this is a `Failure`.

7. #### abstract def isFailure: Boolean

   Returns `true` if the `Try` is a `Failure`, `false` otherwise.

8. #### abstract def isSuccess: Boolean

   Returns `true` if the `Try` is a `Success`, `false` otherwise.

9. #### abstract def map[U](f: (T) ⇒ U): Try[U]

   Maps the given function to the value from this `Success` or returns this if this is a `Failure`.

10. #### abstract def recover[U >: T](f: PartialFunction[Throwable, U]): Try[U]

    Applies the given function `f` if this is a `Failure`, otherwise returns this if this is a `Success`.

    Applies the given function `f` if this is a `Failure`, otherwise returns this if this is a `Success`. This is like map for the exception.

11. #### abstract def recoverWith[U >: T](f: PartialFunction[Throwable, Try[U]]): Try[U]

    Applies the given function `f` if this is a `Failure`, otherwise returns this if this is a `Success`.

    Applies the given function `f` if this is a `Failure`, otherwise returns this if this is a `Success`. This is like `flatMap` for the exception.

### Concrete Value Members

1. #### final def !=(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

2. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     Any

3. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

4. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from Try[T] to StringAdd performed by method any2stringadd in scala.Predef.
   Definition Classes
     StringAdd

5. #### def ->[B](y: B): (Try[T], B)

   Implicit information
     This member is added by an implicit conversion from Try[T] to ArrowAssoc[Try[T]] performed by method any2ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

6. #### final def ==(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

7. #### final def ==(arg0: Any): Boolean

   Test two objects for equality.

   Test two objects for equality. The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     Any

8. #### final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown
     ClassCastException

     if the receiver object is not an instance of the erasure of type `T0`.

9. #### def clone(): AnyRef

   Create a copy of the receiver object.

   Create a copy of the receiver object.

   The default implementation of the `clone` method is platform dependent.

   returns

     a copy of the receiver object.

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws( ... )
   Note

     not specified by SLS as a member of AnyRef

10. #### def ensuring(cond: (Try[T]) ⇒ Boolean, msg: ⇒ Any): Try[T]

    Implicit information
      This member is added by an implicit conversion from Try[T] to Ensuring[Try[T]] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

11. #### def ensuring(cond: (Try[T]) ⇒ Boolean): Try[T]

    Implicit information
      This member is added by an implicit conversion from Try[T] to Ensuring[Try[T]] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

12. #### def ensuring(cond: Boolean, msg: ⇒ Any): Try[T]

    Implicit information
      This member is added by an implicit conversion from Try[T] to Ensuring[Try[T]] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

13. #### def ensuring(cond: Boolean): Try[T]

    Implicit information
      This member is added by an implicit conversion from Try[T] to Ensuring[Try[T]] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

14. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

15. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

16. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

17. #### def formatted(fmtstr: String): String

    Returns string formatted according to given `format` string.

    Returns string formatted according to given `format` string. Format strings are as for `String.format` (@see java.lang.String.format).

    Implicit information
      This member is added by an implicit conversion from Try[T] to StringFormat performed by method any2stringfmt in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

18. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

19. #### def getOrElse[U >: T](default: ⇒ U): U

    Returns the value from this `Success` or the given `default` argument if this is a `Failure`.

    Returns the value from this `Success` or the given `default` argument if this is a `Failure`.

    Note:: This will throw an exception if it is not a success and default throws an exception.

20. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

21. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

22. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

23. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

24. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

25. #### def orElse[U >: T](default: ⇒ Try[U]): Try[U]

    Returns this `Try` if it's a `Success` or the given `default` argument if this is a `Failure`.

26. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

27. #### def toOption: Option[T]

    Returns `None` if this is a `Failure` or a `Some` containing the value if this is a `Success`.

28. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

29. #### def transform[U](s: (T) ⇒ Try[U], f: (Throwable) ⇒ Try[U]): Try[U]

    Completes this `Try` by applying the function `f` to this if this is of type `Failure`, or conversely, by applying `s` if this is a `Success`.

30. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

31. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

32. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

33. #### def →[B](y: B): (Try[T], B)

    Implicit information
      This member is added by an implicit conversion from Try[T] to ArrowAssoc[Try[T]] performed by method any2ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Shadowed Implicit Value Members

1. #### val self: Any

   Implicit information
     This member is added by an implicit conversion from Try[T] to StringAdd performed by method any2stringadd in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (try: StringAdd).self

   Definition Classes
     StringAdd

2. #### val self: Any

   Implicit information
     This member is added by an implicit conversion from Try[T] to StringFormat performed by method any2stringfmt in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (try: StringFormat).self

   Definition Classes
     StringFormat

### Deprecated Value Members

1. #### def x: Try[T]

   Implicit information
     This member is added by an implicit conversion from Try[T] to ArrowAssoc[Try[T]] performed by method any2ArrowAssoc in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (try: ArrowAssoc[Try[T]]).x

   Definition Classes
     ArrowAssoc
   Annotations
     @deprecated
   Deprecated

     (Since version 2.10.0) Use `leftOfArrow`instead``

2. #### def x: Try[T]

   Implicit information
     This member is added by an implicit conversion from Try[T] to Ensuring[Try[T]] performed by method any2Ensuring in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (try: Ensuring[Try[T]]).x

   Definition Classes
     Ensuring
   Annotations
     @deprecated
   Deprecated

     (Since version 2.10.0) Use `resultOfEnsuring`instead``

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from Try[T] to StringAdd

### Inherited by implicit conversion any2stringfmt from Try[T] to StringFormat

### Inherited by implicit conversion any2ArrowAssoc from Try[T] to ArrowAssoc[Try[T]]

### Inherited by implicit conversion any2Ensuring from Try[T] to Ensuring[Try[T]]

### Ungrouped